package jp.hishidama.swing.table.editor;

import java.awt.Color;
import java.awt.Component;
import java.lang.reflect.Method;

import javax.swing.DefaultCellEditor;
import javax.swing.JCheckBox;
import javax.swing.JTable;
import javax.swing.border.LineBorder;

/**
 * booleanGfB^[.
 *
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/java/swing/JTable.html"
 *         >Ђ</a>
 * @since 2009.09.27
 */
public class BooleanEditor extends DefaultCellEditor {
	private static final long serialVersionUID = 3423822347276965549L;

	protected Object dvalue;

	protected Class<?> type;

	/** RXgN^[. */
	public BooleanEditor() {
		super(new JCheckBox());
		getComponent().setHorizontalAlignment(JCheckBox.CENTER);
	}

	@Override
	public JCheckBox getComponent() {
		return (JCheckBox) super.getComponent();
	}

	/**
	 * ҏWJnɌĂ΂.
	 *
	 * @param table
	 *            Ώۃe[u
	 * @param value
	 *            ҏWΏۃf[^ilj
	 * @param isSelected
	 * @param row
	 *            f[^̂sԍ
	 * @param column
	 *            f[^̂ԍ
	 * @return `pR|[lg
	 */
	@Override
	public Component getTableCellEditorComponent(JTable table, Object value,
			boolean isSelected, int row, int column) {
		this.dvalue = null; // 
		getComponent().setBorder(new LineBorder(Color.black)); // ŏ͍g

		Boolean selected;
		if (value == null) {
			selected = false;
			type = null;
		} else {
			type = value.getClass();
			if (value instanceof Boolean) {
				selected = (Boolean) value;
			} else if (value instanceof Number) {
				selected = ((Number) value).intValue() != 0;
			} else {
				selected = Boolean.parseBoolean(value.toString());
			}
		}

		return super.getTableCellEditorComponent(table, selected, isSelected,
				row, column);
	}

	/**
	 * ҏWɌĂ΂.
	 * <p>
	 * super.stopCellEditing()ĂяoƐIƂȂ͗lB
	 * </p>
	 *
	 * @return truȅꍇAIiƎv邪Aۂɂ͉ԂĂ֌Wۂj
	 */
	@Override
	public boolean stopCellEditing() {
		Object d = null;

		Boolean b = (Boolean) super.getCellEditorValue(); // ҏWꂽl̎擾
		if (type == null) {
			d = b;
		} else if (b != null) {
			try {
				if (type == Boolean.class || type == Object.class) {
					d = b;
				} else if (type == String.class) {
					d = b.toString();
				} else {
					Method m = type.getMethod("valueOf", String.class);
					if (b.booleanValue()) {
						d = m.invoke(null, "1");
					} else {
						d = m.invoke(null, "0");
					}
				}
			} catch (Exception e) {
				// G[͐Ԙg\
				getComponent().setBorder(new LineBorder(Color.red));
				return false;
			}
		}

		this.dvalue = d; // Ԃl(ҏWꂽl)ێĂ

		return super.stopCellEditing();
		// super.stopCellEditing()̒getCellEditorValue()Ă΂A
		// JTable#setValueAt()ɂĒlZbgA
		// ҏWpR|[lgA
		// ҏW
	}

	/**
	 * ͂ꂽl(Hς)Ԃ.
	 *
	 * @return ҏWꂽl
	 */
	@Override
	public Object getCellEditorValue() {
		return dvalue;
	}
}
